XdkWrl: Anchor Class Reference

Home | Hierarchy | Members | Alphabetical | Related Pages

# Anchor Class Reference
[Standard Node Types]

`#include <anchor.h>`

Inherits Node.

List of all members.

## Public Member Functions
| Anchor (const char *name="")
virtual | ~Anchor ()
virtual unsigned int | nbFields () const
virtual FieldHandle | field (const std::string &n)
virtual FieldHandle | field (unsigned int i)
virtual bool | isSetToDefaultValue (unsigned int i) const
virtual unsigned int | nbEventsIn () const
virtual EventInHandle | eventIn (const std::string &n)
virtual EventInHandle | eventIn (unsigned int i)
virtual unsigned int | nbEventsOut () const
virtual EventOutHandle | eventOut (const std::string &n)
virtual EventOutHandle | eventOut (unsigned int i)
const char * | typeName () const
virtual Node * | duplicate () const
virtual Node * | duplicate (std::map< const Node *, Node * > &) const
## Public Attributes
Exposed Fields
A field that is capable of receiving events via an eventIn to change its value(s), and generating events via an eventOut when its value(s) change.
MFNode | children
SFString | description
MFString | parameter
MFString | url
Fields
A property or attribute of a node. Each node type has a fixed set of fields. Fields may contain various kinds of data and one or many values. Each field has a default value.
SFVec3f | bboxCenter
SFVec3f | bboxSize
Events In
EventIn< MFNode > | addChildren
EventIn< MFNode > | removeChildren
EventIn< MFNode > | set_children
EventIn< SFString > | set_description
EventIn< MFString > | set_parameter
EventIn< MFString > | set_url
Events Out
EventOut< MFNode > | children_changed
EventOut< SFString > | description_changed
EventOut< MFString > | parameter_changed
EventOut< MFString > | url_changed

## Detailed Description

Here is the documentation for this node type, from the ISO standard.

## 6.2 Anchor

The Anchor grouping node retrieves the content of a URL when the user activates (e.g., clicks) some geometry contained within the Anchor node's children. If the URL points to a valid VRML file, that world replaces the world of which the Anchor node is a part (except when the parameter field, described below, alters this behaviour). If non-VRML data is retrieved, the browser shall determine how to handle that data; typically, it will be passed to an appropriate non-VRML browser.

Exactly how a user activates geometry contained by the Anchor node depends on the pointing device and is determined by the VRML browser. Typically, clicking with the pointing device will result in the new scene replacing the current scene. An Anchor node with an empty url does nothing when its children are chosen. A description of how multiple Anchors and pointing-device sensors are resolved on activation is contained in 4.6.7, Sensor nodes.

More details on the children, addChildren, and removeChildren fields and eventIns can be found in 4.6.5, Grouping and children nodes.

The description field in the Anchor node specifies a textual description of the Anchor node. This may be used by browser-specific user interfaces that wish to present users with more detailed information about the Anchor.

The parameter exposed field may be used to supply any additional information to be interpreted by the browser. Each string shall consist of "keyword=value" pairs. For example, some browsers allow the specification of a 'target' for a link to display a link in another part of an HTML document. The parameter field is then:

    Anchor {
      parameter [ "target=name_of_frame" ]
      ...
    }

An Anchor node may be used to bind the initial Viewpoint node in a world by specifying a URL ending with "#ViewpointName" where "ViewpointName" is the name of a viewpoint defined in the VRML file. For example:

    Anchor {
      url "http://www.school.edu/vrml/someScene.wrl#OverView"
      children  Shape { geometry Box {} }
    }

specifies an anchor that loads the VRML file "someScene.wrl" and binds the initial user view to the Viewpoint node named "OverView" when the Anchor node's geometry (Box) is activated. If the named Viewpoint node is not found in the VRML file, the VRML file is loaded using the default Viewpoint node binding stack rules (see 6.53, Viewpoint).

If the url field is specified in the form "#ViewpointName" (i.e. no file name), the Viewpoint node with the given name ("ViewpointName") in the Anchor's run-time name scope(s) shall be bound (set_bind TRUE). The results are undefined if there are multiple Viewpoints with the same name in the Anchor's run-time name scope(s). The results are undefined if the Anchor node is not part of any run-time name scope or is part of more than one run-time name scope. See 4.4.6, Run-time name scope, for a description of run-time name scopes. See 6.53, Viewpoint, for the Viewpoint transition rules that specify how browsers shall interpret the transition from the old Viewpoint node to the new one. For example:

    Anchor {
      url "#Doorway"
      children Shape { geometry Sphere {} }
    }

binds the viewer to the viewpoint defined by the "Doorway" viewpoint in the current world when the sphere is activated. In this case, if the Viewpoint is not found, no action occurs on activation.

More details on the url field are contained in 4.5, VRML and the World Wide Web.

The bboxCenter and bboxSize fields specify a bounding box that encloses the Anchor's children. This is a hint that may be used for optimization purposes. The results are undefined if the specified bounding box is smaller than the actual bounding box of the children at any time. The default bboxSize value, (-1, -1, -1), implies that the bounding box is not specified and if needed shall be calculated by the browser. More details on the bboxCenter and bboxSize fields can be found in 4.6.4, Bounding boxes.

## Constructor & Destructor Documentation

Anchor | ( | const char * | name = `""` | ) |

Construct a node with all its fields set to default value, which is equivalent to the code below:

      description = string("");
      bboxCenter.setXYZ(0,0,0);
      bboxSize.setXYZ(-1,-1,-1);

~Anchor | ( |  | ) | `[virtual]`

Virtual destructor, does nothing

## Member Function Documentation

unsigned int nbFields | ( |  | ) | const`[inline, virtual]`

Returns the number of fields (exposed or not) for this node type.

Implements Node.

wrl::Node::FieldHandle field | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the field named `n` of the node or a "unknown" typed handle if there is no such field. Valid names are:

- children
- description
- parameter
- url
- bboxCenter
- bboxSize

Implements Node.

wrl::Node::FieldHandle field | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th field of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : children
- 1 : description
- 2 : parameter
- 3 : url
- 4 : bboxCenter
- 5 : bboxSize This function is useful, with nbFields() if you want to traverse all fields of a Node.

Implements Node.

bool isSetToDefaultValue | ( | unsigned int | i | ) | const`[virtual]`

Implements Node.

unsigned int nbEventsIn | ( |  | ) | const`[inline, virtual]`

Returns the number of events in for this node type.

Implements Node.

wrl::Node::EventInHandle eventIn | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event in named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- addChildren
- removeChildren
- set_children
- set_description
- set_parameter
- set_url

Implements Node.

wrl::Node::EventInHandle eventIn | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event in of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : addChildren
- 1 : removeChildren
- 2 : set_children
- 3 : set_description
- 4 : set_parameter
- 5 : set_url

This function is useful, with nbEventsIn() if you want to traverse all events in of a Node.

Implements Node.

unsigned int nbEventsOut | ( |  | ) | const`[inline, virtual]`

Returns the number of events out for this node type.

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event out named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- children_changed
- description_changed
- parameter_changed
- url_changed

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event out of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : children_changed
- 1 : description_changed
- 2 : parameter_changed
- 3 : url_changed This function is useful, with nbEventsOut() if you want to traverse all events in of a Node.

Implements Node.

const char * typeName | ( |  | ) | const`[inline, virtual]`

Returns `"Anchor"`. Useful for printing.

Implements Node.

wrl::Node * duplicate | ( |  | ) | const`[virtual]`

Returns a deep copy of this node, that is a fully independant node with all children (if any) also copied. This is mainly useful for instanciating protos.

Implements Node.

virtual Node* duplicate | ( | std::map< const Node *, Node * > & |  | ) | const`[virtual]`

Implements Node.

## Member Data Documentation

MFNode children

See Detailed Description for meaning of this field. Default value is set to MFNode default value

SFString description

See Detailed Description for meaning of this field. Default value is set to

           description = string("");

MFString parameter

See Detailed Description for meaning of this field. Default value is set to MFString default value

MFString url

See Detailed Description for meaning of this field. Default value is set to MFString default value

SFVec3f bboxCenter

See Detailed Description for meaning of this field. Default value is set to

           bboxCenter.setXYZ(0,0,0);

SFVec3f bboxSize

See Detailed Description for meaning of this field. Default value is set to

           bboxSize.setXYZ(-1,-1,-1);

EventIn<MFNode> addChildren

See Detailed Description for meaning of this event.

EventIn<MFNode> removeChildren

See Detailed Description for meaning of this event.

EventIn<MFNode> set_children

Set event associated to exposedField children

EventIn<SFString> set_description

Set event associated to exposedField description

EventIn<MFString> set_parameter

Set event associated to exposedField parameter

EventIn<MFString> set_url

Set event associated to exposedField url

EventOut<MFNode> children_changed

Changed event associated to exposedField children

EventOut<SFString> description_changed

Changed event associated to exposedField description

EventOut<MFString> parameter_changed

Changed event associated to exposedField parameter

EventOut<MFString> url_changed

Changed event associated to exposedField url

Generated on 5 Jan 2007 with version 1.5.1. |